abuild.in 22.5 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
apkcache=@apkcache@
Natanael Copa's avatar
Natanael Copa committed
14 15 16

startdir="$PWD"
srcdir=${srcdir:-"$startdir/src"}
17
pkgbasedir=${pkgbasedir:-"$startdir/pkg"}
Natanael Copa's avatar
Natanael Copa committed
18
pkgrel=0
Natanael Copa's avatar
Natanael Copa committed
19 20
repo=${startdir%/*}
repo=${repo##*/}
Natanael Copa's avatar
Natanael Copa committed
21 22 23 24

# defaults
SRCDEST=${SRCDEST:-$startdir}
PKGDEST=${PKGDEST:-$startdir}
25
BUILD_BASE="build-base"
Natanael Copa's avatar
Natanael Copa committed
26

27 28
SUDO=${SUDO:-"sudo"}

29
default_cmds="sanitycheck builddeps clean fetch unpack rootpkg apkcache"
Natanael Copa's avatar
Natanael Copa committed
30

Natanael Copa's avatar
Natanael Copa committed
31
# read config
Natanael Copa's avatar
Natanael Copa committed
32
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
33 34
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

Natanael Copa's avatar
Natanael Copa committed
35
# source functions
36 37
datadir=/usr/share/abuild

Natanael Copa's avatar
Natanael Copa committed
38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69
#colors
if [ -n "$USE_COLORS" ]; then
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
Natanael Copa's avatar
Natanael Copa committed
70 71

	
Linux User's avatar
Linux User committed
72 73
set_xterm_title() {
	if [ "$TERM" = xterm ]; then
74
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
75 76 77 78 79
	fi
} 

cleanup() {
	set_xterm_title ""
80
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
81
		$SUDO apk del $uninstall_after
82
	fi
Linux User's avatar
Linux User committed
83 84
}

Natanael Copa's avatar
Natanael Copa committed
85
die() {
Linux User's avatar
Linux User committed
86
	error "$@"
Linux User's avatar
Linux User committed
87
	cleanup
Natanael Copa's avatar
Natanael Copa committed
88 89 90
	exit 1
}

91 92
# check if apkbuild is basicly sane
sanitycheck() {
Natanael Copa's avatar
Natanael Copa committed
93
	local i
94
	msg "Checking sanity of $APKBUILD..."
95 96 97
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
98 99
	apk version --check -q "$pkgver" ||\
		die "$pkgver is not a valid version"
100 101 102 103 104
	[ -z "$pkgrel" ] && warning "Missing pkgrel in APKBUILD. Using pkgrel=0"
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

105 106 107
	if [ -n "$source" ]; then
		for i in $source; do
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
Natanael Copa's avatar
Natanael Copa committed
108 109 110
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
111 112
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
113

114 115 116 117 118
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
			source_has $i || die "$i is missing in source"
		done
	fi
119

120 121 122
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
123 124

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
125 126

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
127 128 129 130
	return 0
}

md5check() {
Natanael Copa's avatar
Natanael Copa committed
131
	local dummy f
132 133 134
	if [ -z "$source" ]; then
		return 0
	fi
135
	if [ -z "$md5sums" ]; then
136
		die "Use 'abuild checksum' to generate/update the checksum(s)"
137
	fi
138 139 140
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
141
	fetch || return 1
142
	msg "Checking md5sums..."
143
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
144 145 146 147 148
}

uri_fetch() {
	local uri="$1"
	local d="${s##*/}"	# $(basename $s)
149 150 151 152
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

Natanael Copa's avatar
Natanael Copa committed
153 154 155 156 157 158
	
	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
	
Natanael Copa's avatar
Natanael Copa committed
159
	mkdir -p "$SRCDEST"
160 161 162
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
163
	fi
Linux User's avatar
Linux User committed
164
	msg "Fetching $uri"
165 166
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
167 168
}

169 170
is_remote() {
	case "$1" in
Natanael Copa's avatar
Natanael Copa committed
171
		http://*|ftp://*|https://*)
172 173 174 175 176
			return 0;;
	esac
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
177 178 179
fetch() {
	local s
	mkdir -p "$srcdir"
180 181 182 183 184 185 186
	for s in $source; do
		if is_remote "$s"; then
			uri_fetch "$s" || return 1
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
187 188 189 190 191 192
	done
}

# unpack the sources
unpack() {
	local u
193
	md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
194 195 196 197
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
198
			*.tar.gz|*.tgz)
199
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
200 201
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
202
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
203
				tar -C "$srcdir" -jxf "$s" || return 1;;
204 205 206 207
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
Natanael Copa's avatar
Natanael Copa committed
208 209 210
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
211 212 213 214 215 216
		esac
	done
}

# cleanup source and package dir
clean() {
217
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
218
	rm -rf "$srcdir"
219
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
220 221 222 223 224 225
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
226 227 228 229
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
230 231 232 233 234
	done
}

cleanpkg() {
	local i
235
	msg "Cleaning built packages..."
236
	for i in $pkgname $subpackages; do
237 238
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
239
			"$apkcache"/$p.apk
Natanael Copa's avatar
Natanael Copa committed
240
	done
241 242
	# remove given packages from index

Natanael Copa's avatar
Natanael Copa committed
243 244
}

245 246 247 248 249 250 251 252 253 254 255 256 257
# clean all packages except current
cleanoldpkg() {
	local i j
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
	for i in $pkgname $subpackages; do
		for j in "$PKGDEST"/${i%:*}-[0-9]*.apk; do
			[ "$j" != "$PKGDEST/${i%:*}-$pkgver-r$pkgrel.apk" ] \
				&& rm -f "$j"
		done
	done
	return 0
}
	
Natanael Copa's avatar
Natanael Copa committed
258 259
runpart() {
	local part=$1
260
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
261 262 263 264 265 266 267 268
	$part || die "$part failed"
}

# override those in your build script
build() {
	die "No build() function found in $APKBUILD"
}

Natanael Copa's avatar
Natanael Copa committed
269 270 271 272 273 274 275 276 277
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

278
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
279
	if [ -z "$subpackages" ]; then
280 281
		return 0
	fi
Natanael Copa's avatar
Natanael Copa committed
282 283
	local i
	cd "$startdir"
284
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
285 286
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
287
		msg "Running split function $func..."
288
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
289
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
290 291 292
	done
}

293
prepare_metafiles() {
294 295
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
296
	local dir=${subpkgdir:-$pkgdir}
297
	local pkg="$name-$pkgver-r$pkgrel.apk"
298
	local pkginfo="$controldir"/.PKGINFO
299
	local sub
Natanael Copa's avatar
Natanael Copa committed
300 301 302
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
303
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
304 305 306
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')

307
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
308
	if [ -n "$FAKEROOTKEY" ]; then
309
		echo "# using $(fakeroot -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
310
	fi
311 312
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
313
pkgname = $name
314
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
315 316 317 318 319 320
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
EOF
321 322
	local i deps
	deps="$depends"
323 324 325 326 327 328 329 330
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
		for i in $install; do
			if head -n 1 "$srcdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
331 332
	fi
	
Natanael Copa's avatar
Natanael Copa committed
333
	for i in $license; do
334
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
335 336
	done
	for i in $replaces; do
337
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
338
	done
339
	for i in $deps; do
340
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
341 342
	done
	for i in $conflicts; do
343
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
344 345
	done
	for i in $provides; do
346
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
347 348
	done
	for i in $backup; do
349
		echo "backup = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
350 351 352
	done

	local metafiles=".PKGINFO"
353 354 355 356 357 358 359 360 361 362
	for i in $install; do
		script=${i#$name}
		case "$script" in
			.pre-install|.post-install|.pre-upgrade|.post-upgrade|.pre-deinstall|.post-deinstall)
				msg "Adding $script"
				;;
			*) 	error "$script: Invalid install script"
				return 1
				;;
		esac
363 364
		cp "$srcdir/$i" "$controldir/$script" || return 1
		chmod +x "$controldir/$script"
365 366
		metafiles="$metafiles $script"
	done
367
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
368
}
369

370 371 372
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
	options_has "!tracedeps" && return 0
373 374
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
375
	scanelf -Rn "$dir" | awk -F "\ " '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
376 377 378
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
379 380
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
381
	done
Natanael Copa's avatar
Natanael Copa committed
382 383
}

384
prepare_package() {
385
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
386
	stripbin
387
	prepare_metafiles
388
	prepare_tracedeps
389 390 391 392 393 394 395 396
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

397 398 399
trace_apk_deps() {
	local name="$1"
	local dir="$2"
400 401
	local i j found autodeps=
	msg "Tracing dependencies for $name..."
402
	for i in $(cat "$dir"/.needs-so 2>/dev/null); do
403
		found=
404
		# first check if its provide by same apkbuild
405
		for j in "$dir"/../.control.*/.provides-so; do
406
			grep -w "$i" "$j" >/dev/null || continue
407
			found=${j%/.provides-so}
408
			found=${found##*/.control.}
409
			break
410 411 412 413 414 415 416 417 418 419 420 421 422
		done
		# check apk db if not provided by a subpackage
		if [ -z "$found" ]; then
			found=$(apk info -q -W /lib/$i /usr/lib/$i)
		fi
		if [ -z "$found" ]; then
			error "Could not find dependency for $i"
			return 1
		fi
		if grep -w "^depend = $found" "$dir"/.PKGINFO >/dev/null ; then
			warning "You can remove '$found' from depends"
			continue
		fi
423 424
		list_has "$found" $autodeps || autodeps="$autodeps $found"
		msg "Added '$found' as dependency as it has $i"
425 426 427 428 429 430 431 432
	done
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

433 434
create_apks() {
	local file
435
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
436 437 438
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
439
		local apk=$name-$ver.apk
440
		local datadir="$pkgbasedir"/$name
441 442

		trace_apk_deps "$name" "$dir" || return 1
443
		msg "Creating $apk..."
444
		(
445 446 447 448 449 450 451 452 453
		cd "$datadir"
		# data.tar.gz
		tar -c . | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
454
		cd "$dir"
455 456
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
Natanael Copa's avatar
Natanael Copa committed
457

458 459 460
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
461 462 463
	done
}

464
apkcache() {
465
	if ! apk_up2date || [ -n "$force" ]; then
466 467 468
		sanitycheck && builddeps && clean && fetch && unpack && rootpkg || return 1
	fi
	local apk
469
	mkdir -p "$apkcache" || return 1
470
	set --
471
	for apk in $(listpkg); do
472
		ln -sf "$PKGDEST"/$apk "$apkcache"/$apk
473 474
	done

475
	# update the apkcache cache here
476
	msg "Updating the cached abuild repository index..."
477
	apk index -o "$apkcache"/APKINDEX.tar.gz "$apkcache"/*.apk
478 479
}

480
# predefined splitfunc doc
481
default_doc() {
482
	depends="$depends_doc"
483
	install="$install_doc"
Natanael Copa's avatar
Natanael Copa committed
484
	local i
485
	for i in doc man info html sgml licenses gtk-doc; do
486 487 488
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
489 490
		fi
	done
491 492 493
	
	rm -f "$subpkgdir/usr/share/info/dir"

494 495 496
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
497 498 499 500

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
501
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
502 503 504
	return 0
}

505 506 507 508
doc() {
	default_doc
}

509
# predefined splitfunc mod
510
default_mod() {
511
	depends="$kernel $depends_mod"
512
	install="$install_mod"
Natanael Copa's avatar
Natanael Copa committed
513
	for i in firmware modules; do
514 515 516
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
517
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
518 519 520 521
		fi
	done
}

522 523 524 525
mod() {
	default_mod
}

526
# predefined splitfunc dev
527
default_dev() {
528
	depends="$pkgname $depends_dev"
529
	install="$install_dev"
530
	cd "$pkgdir" || return 0
531 532 533 534 535
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
536 537
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
538
			mkdir -p "$d"
539
			mv "$pkgdir/$i" "$d"
540
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
541 542
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
543
	return 0
Natanael Copa's avatar
Natanael Copa committed
544 545
}

546 547 548 549
dev() {
	default_dev
}

Natanael Copa's avatar
Natanael Copa committed
550 551
# build and package in fakeroot
rootpkg() {
Natanael Copa's avatar
Natanael Copa committed
552
	cd "$startdir"
553
	msg "Entering fakeroot..."
554
	fakeroot $0 build prepare_subpackages prepare_package create_apks
Natanael Copa's avatar
Natanael Copa committed
555 556 557
}

srcpkg() {
558
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
559
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
560 561 562 563 564
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
565
	msg "Creating source package $p.src.tar.gz..."
566
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
567 568
}

569
# check if package is up to date
570
apk_up2date() {
571
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
572
	local i s
Natanael Copa's avatar
Natanael Copa committed
573
	cd "$startdir"
574 575 576 577 578
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

579
	for i in $source APKBUILD; do
580 581 582 583 584 585
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
586 587 588 589 590 591 592
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

593 594 595 596 597 598 599 600 601 602 603 604 605
cache_up2date() {
	local i apk
	for i in $pkgname $subpackages; do
		apk="${i%:*}-$pkgver-r$pkgrel.apk"
		[ "$apkcache"/APK_INDEX.gz -nt "$apkcache"/$apk ] || return 1
	done
	return 0
}

up2date() {
	apk_up2date && cache_up2date
}

606 607 608 609 610 611 612 613 614 615 616 617 618
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/../..)
	for i in $aportsdir/*/*/APKBUILD; do
		pkgname=
		subpackages=
		depends=
		makedepends=
619
		. $i
620
		dir=${i%/APKBUILD}
621 622 623 624 625 626 627 628
		deps=
		# filter out conflicts from deps
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
			deps="$deps $j"
		done
629
		for j in $pkgname $subpackages; do
630
			echo "o ${j%%:*} $dir"
631
			set -- $deps
632 633 634 635 636 637 638
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
639 640
		done
	done
641
	)
642 643
}

644
deptrace() {
645 646
	local deps="$@"
	[ -z "$deps" ] && deps="$BUILD_BASE $depends $makedepends"
647 648 649
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
Natanael Copa's avatar
abuild:  
Natanael Copa committed
650
			apk info -q | sort |  sed 's/^/i /'
651
		fi
652
	) | awk -v pkgs="$deps" '
653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672 673 674 675 676 677

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
678 679
	local deps alldeps pkg i dir ver missing installed_deps
	msg "Analyzing dependencies..."
680 681
	deps="$BUILD_BASE $makedepends"

682

683 684 685 686 687
	# add depends unless it is a subpackage
	for i in $depends; do
		subpackages_has $i || deps="$deps $i"
	done

688
	installed_deps=$(apk info -e $deps)
689
	# find which deps are missing
690
	for i in $deps; do
691
		if [ "${i#\!}" != "$i" ]; then
692
			list_has ${i#\!} $installed_deps \
693
				&& die "Conflicting package ${i#\!} is installed."
694
		elif ! list_has $i $installed_deps; then
695 696 697 698 699 700 701
			if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
				die "Missing dependency $i. Use -r to autoinstall or -R to build"
			fi
			missing="$missing $i"
		fi
	done

702 703
	[ -z "$missing" ] && [ -z "$install_deps" ] && [ -z "$recursive" ] \
		&& return 0
704

705
	uninstall_after=".makedepends-$pkgname $uninstall_after"
706
	if [ -n "$install_deps" ] && [ -z "$recursive" ]; then
707
		$SUDO apk add --repo "$apkcache" \
708 709
			--virtual .makedepends-$pkgname $deps \
			&& return 0
710
	fi
711 712 713 714
	
	[ -z "$recursive" ] && return 1
	
	for i in $(deptrace $missing); do
715 716 717 718
		# i = pkg:dir
		local dir=${i#*:}
		local pkg=${i%:*}
		msg "Entering $dir"
719
		cd "$dir" && $0 -k -r apkcache || return 1
720
	done
721
	$SUDO apk add -u --repo "$apkcache" \
722
		--virtual .makedepends-$pkgname $deps
723 724
}

725
# replace the md5sums in the APKBUILD
Natanael Copa's avatar
Natanael Copa committed
726 727
checksum() {
	local s files
728
	[ -z "$source" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
729
	fetch
730
	msg "Updating the md5sums in APKBUILD..."
Natanael Copa's avatar
Natanael Copa committed
731 732 733 734
	for s in $source; do
		files="$files ${s##*/}"
	done
	md5sums="$(cd "$srcdir" && md5sum $files)" || die "md5sum failed"
735 736
	sed -i -e '/^md5sums="/,/"\$/d; /^md5sums=''/,/''\$/d' "$APKBUILD"
	echo "md5sums=\"$md5sums\"" >>"$APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
737 738
}

739
stripbin() {
740
	local bin
741
	options_has "!strip" && return 0
742 743
	cd "${subpkgdir:-$pkgdir}" || return 1
	msg "Stripping binaries"
744
	find . -type f 2>/dev/null | while read bin; do
745 746 747 748 749 750 751 752 753 754 755
		local opt=
		case "$(file -biz "$bin")" in
			*/x-sharedlib*|*/x-archive*)
				strip --strip-debug "$bin";;
			*/x-executable*)
				strip "$bin";;
		esac
	done
	return 0
}

756 757 758 759 760 761 762 763
# simply list target apks
listpkg() {
	local i 
	for i in $pkgname $subpackages; do
		echo "${i%:*}-$pkgver-r$pkgrel.apk"
	done
}

Natanael Copa's avatar
Natanael Copa committed
764 765 766 767 768 769 770 771
source_has() {
	local i
	for i in $source; do
		[ "$1" = "${i##*/}" ] && return 0
	done
	return 1
}

Natanael Copa's avatar
abuild:  
Natanael Copa committed
772 773 774 775 776 777 778 779
subpackages_has() {
	local i
	for i in $subpackages; do
		[ "$1" = "${i%:*}" ] && return 0
	done
	return 1
}

780 781 782 783 784 785 786 787 788 789 790 791 792 793 794
list_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

options_has() {
	list_has "$1" $options
}

795 796 797 798
depends_has() {
	list_has "$1" $depends
}

Natanael Copa's avatar
Natanael Copa committed
799 800 801 802
makedepends_has() {
	list_has "$1" $makedepends
}

Natanael Copa's avatar
Natanael Copa committed
803 804 805 806
md5sums_has() {
	list_has "$1" $md5sums
}

Natanael Copa's avatar
abuild:  
Natanael Copa committed
807 808 809 810 811 812 813 814 815 816 817 818 819 820
# install package after build
post_add() {
	local pkgf="$PKGDEST/$1-$pkgver-r$pkgrel.apk"
	local deps i
	if ! subpackages_has $1 && [ "$1" != "$pkgname" ]; then
		die "$1 is not built by this APKBUILD"
	fi
	# recursively install dependencies that are provided by this APKBUILD
	deps=$(apk index "$pkgf" 2>/dev/null | awk -F: '$1=="D" { print $2 }')
	for i in $deps; do
		if subpackages_has $i || [ "$i" = "$pkgname" ]; then
			post_add $i || return 1
		fi
	done
821
	$SUDO apk add -u "$pkgf" || die "Failed to install $1"
Natanael Copa's avatar
abuild:  
Natanael Copa committed
822 823
}

824 825 826 827 828 829 830 831 832 833 834 835 836 837 838 839 840 841 842 843 844 845 846
# create new aport from templates
newaport() {
	local pn=${newname%-[0-9]*}
	local pv
	if [ "$pn" != "$newname" ]; then
		pv=${newname#$pn-}
	fi
	if [ -e "$pn"/APKBUILD ]; then
		error "$pn/APKBUILD already exist"
		return 1
	fi
	mkdir -p "$pn"
	cd "$pn"
	sed 	-e '1,/^\#*$/d' \
		-e "s/^\(# Contributor: \).*/\1$PACKAGER/" \
		-e "s/^\(# Maintainer: \).*/\1$PACKAGER/" \
		-e "s/^pkgname=.*/pkgname=$pn/" \
		-e "s/^pkgver=.*/pkgver=$pv/" \
		"$datadir"/sample.APKBUILD > APKBUILD || return 1
	#-e '1,/^\#$/d' \
	if [ -n "$cpinitd" ]; then
		cp "$datadir"/sample.initd $pn.initd
		cp "$datadir"/sample.confd $pn.confd
847 848 849
		cp "$datadir"/sample.pre-install $pn.pre-install
		cp "$datadir"/sample.post-install $pn.post-install
		sed -i -e "s/^install=.*/install=\"\$pkgname.pre-install \$pkgname.post-install\"/" \
850 851 852 853 854
			-e "s/^source=\"\(.*\)\"/source=\"\1\n\t$pn.initd\n\t$pn.confd\n\t\$install\n\t\"/" \
			APKBUILD
		
	fi
}
855 856

installdeps() {
857
	local deps i
858
	sudo apk add --repo "$apkcache" --virtual .makedepends-$pkgname \
859
		$makedepends
860 861 862
}

uninstalldeps (){
863
	sudo apk del .makedepends-$pkgname
864
}
865 866 867 868 869 870 871 872 873

all() {
	if up2date && [ -z "$force" ]; then
		msg "Package is up to date"
	else
		apkcache
	fi
}

Natanael Copa's avatar
Natanael Copa committed
874
usage() {
875
	echo "$(basename $0) $abuild_ver"
876 877
	echo "usage: ${0##*/} [options] [-i PKG] [-P REPODEST] [-p PKGDEST]"
	echo "              [-s SRCDEST] [cmd] ..."
878
	echo "       ${0##*/} [-c] -n PKGNAME[-PKGVER]"
Natanael Copa's avatar
Natanael Copa committed
879 880
	echo "Options:"
	echo " -f  Force specified cmd, even if they are already done"
881 882
	echo " -h  Show this help"
	echo " -i  Install PKG after successul build"
883
	echo " -k  Keep built packages, even if APKBUILD or sources are newer"
884
	echo " -p  Set package destination directory"
885
	echo " -P  Set PKGDEST to REPODEST/<repo>, where repo is the parents dir name" 
Natanael Copa's avatar
Natanael Copa committed
886
	echo " -q  Quiet"
887 888
	echo " -r  Install missing dependencies from system repository (using sudo)"
	echo " -R  Recursively build and install missing dependencies (using sudo)"
889
	echo " -s  Set source package destination directory"
890
	echo " -u  Recursively build and upgrade all dependencies (using sudo)"
Natanael Copa's avatar
Natanael Copa committed
891
	echo ""
892 893 894
	echo " -n  Create a new APKBUILD in a directory named PKGNAME"
	echo " -c  Copy a sample init.d, conf.d and install script to new directory"
	echo ""
Natanael Copa's avatar
Natanael Copa committed
895
	echo "Commands:"
896
	echo "  checksum    Generate checksum to be included in APKBUILD"
897 898 899 900 901
	echo "  fetch       Fetch sources to \$SRCDEST and verify checksums"
	echo "  sanitycheck Basic sanity check of APKBUILD"
	echo "  md5check    Check md5sums"
	echo "  unpack      Unpack sources to \$srcdir"
	echo "  build       Compile and install package into \$pkgdir"
902
	echo "  listpkg     List target packages"
903 904 905
	echo "  package     Create package in \$PKGDEST"
	echo "  rootpkg     Run '$0 build package' as fakeroot"
	echo "  clean       Remove temp build and install dirs"
906
	echo "  cleanoldpkg Remove binary packages except current version"
907 908 909 910
	echo "  cleanpkg    Remove already built binary and source package"
	echo "  cleancache  Remove downloaded files from \$SRCDEST"
	echo "  srcpkg      Make a source package"
	echo "  up2date     Compare target and sources dates"
911 912
	echo "  installdeps Install packages listed in makedepends and depends"
	echo "  uninstalldeps Uninstall packages listed in makedepends and depends"
Natanael Copa's avatar
Natanael Copa committed
913 914 915 916 917
	echo ""
	exit 0
}

APKBUILD="${APKBUILD:-./APKBUILD}"
918 919
unset force
unset recursive
920
while getopts "cfhi:kin:p:P:qrRs:u" opt; do
Natanael Copa's avatar
Natanael Copa committed
921
	case $opt in
922
		'c') cpinitd=1;;
Natanael Copa's avatar
Natanael Copa committed
923
		'f') force=1;;
924 925
		'h') usage;;
		'i') install_after="$install_after $OPTARG";;
926
		'k') keep=1;;
927
		'n') newname=$OPTARG;;
928
		'p') PKGDEST=$OPTARG;;
929
		'P') REPODEST=$OPTARG;;
Natanael Copa's avatar
Natanael Copa committed
930
		'q') quiet=1;;
931 932
		'r') install_deps=1;;
		'R') recursive=1;;
933
		's') SRCDEST=$OPTARG;;
934 935
		'u') upgrade=1
		     recursive=1;;
Natanael Copa's avatar
Natanael Copa committed
936 937 938 939
	esac
done
shift $(( $OPTIND - 1 ))

940 941 942 943 944
# If REPODEST is set then it will override the PKGDEST
if [ -n "$REPODEST" ]; then
	PKGDEST="$REPODEST/$repo"
fi

945
# source the buildfile
946 947 948 949
if [ -z "$newname" ]; then
	[ -f "$APKBUILD" ] || die "Could not find $APKBUILD (PWD=$PWD)"
	. "$APKBUILD"
fi
950

951
# If we are handling a sub package then reset subpackages and install
952 953
if [ -n "$subpkgname" ]; then
	subpackages=
954
	install=
955
fi
956
pkgdir="$pkgbasedir/$pkgname"
957
controldir="$pkgbasedir"/.control.${subpkgname:-$pkgname}
Natanael Copa's avatar
Natanael Copa committed
958 959

trap 'die "Aborted by user"' INT
Linux User's avatar
Linux User committed
960
set_xterm_title "abuild: $pkgname"
Natanael Copa's avatar
Natanael Copa committed
961

962 963 964
if [ -z "$1" ] && [ -n "$newname" ]; then
	set "newaport"
fi
Natanael Copa's avatar
Natanael Copa committed
965 966

if [ -z "$1" ]; then
967
	set all
Natanael Copa's avatar
Natanael Copa committed
968 969 970 971 972 973
fi

while [ $# -gt 0 ]; do
	runpart $1
	shift
done
974 975

for i in $install_after; do
Natanael Copa's avatar
abuild:  
Natanael Copa committed
976
	post_add $i
977 978
done

Linux User's avatar
Linux User committed
979
cleanup
Natanael Copa's avatar
Natanael Copa committed
980